// QuizSetupProperty.cpp : implementation file
//
#include "stdafx.h"
#include "resource.h"
#include "QuizSetupProperty.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CQuizSetupProperty

//IMPLEMENT_DYNAMIC(CQuizSetupProperty, CPropertySheet)

CQuizSetupProperty::CQuizSetupProperty(UINT nIDCaption, CWnd* pParentWnd, UINT iSelectPage)
	:CPropertySheet(nIDCaption, pParentWnd, iSelectPage)
{
}

CQuizSetupProperty::CQuizSetupProperty(LPCTSTR pszCaption, CQuizSetting* pQuiz, CTemplate* pTemplate, UINT uiMaxCards, CWnd* pParentWnd=NULL, UINT iSelectPage=0 );
	:CPropertySheet(pszCaption, pParentWnd, iSelectPage)
{
	m_pQuizSetting = pQuiz;

	m_uiMaxCards = uiMaxCards;
	m_pTemplate = pTemplate;

	m_bRebuildFont = FALSE;

		

}

CQuizSetupProperty::~CQuizSetupProperty()
{
}


BEGIN_MESSAGE_MAP(CQuizSetupProperty, CPropertySheet)
	//{{AFX_MSG_MAP(CQuizSetupProperty)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CQuizSetupProperty message handlers

BOOL CQuizSetupProperty::OnInitDialog() 
{
	CPropertySheet::OnInitDialog();
	
	// TODO: Add your specialized code here
	
	/* Init ƾ..   ۵Ǵ  ű  */

	if( GetPageCount() < 3 ) {
		CString strMsg;
		strMsg = "CQuizSetupProperty::OnInitDialog() failed";
		MessageBox(strMsg, AfxGetAppName(), MB_OK | MB_ICONWARNING);
		return FALSE;
	}

	//   .
	// GetPage(1) ̷  ȣϸ   ȵǹǷ,  derived class page CQuizSetupProperty ü   ֵ ؾ Ѵ.
	m_bInternalExam = m_pQuizSetting->IsInternalExamMode();
	m_bQuizResultSync = m_pQuizSetting->IsQuizResultSync();
	GetDlgItem(IDC_ANSWER)->EnableWindow(m_bInternalExam != TRUE);

	m_nNumQuiz = m_pQuizSetting->GetTotalQuiz();
	if (m_nNumQuiz > m_uiMaxCards)
		m_nNumQuiz = m_uiMaxCards;
	m_uiFontSize = m_pQuizSetting->GetFontSize();
	m_uiStartCardNum = m_pQuizSetting->GetStartCardIndex() + 1;
	m_uiEndCardNum = m_pQuizSetting->GetEndCardIndex() + 1;
	SendDlgItemMessage(IDC_START_CARD_NUM_SPIN,UDM_SETRANGE,0,MAKELONG(m_uiMaxCards, 1));
	SendDlgItemMessage(IDC_END_CARD_NUM_SPIN,UDM_SETRANGE,0,MAKELONG(m_uiMaxCards, 1));

	//List ߰ 
	int i;
	for (i = 0; i < MAX_ITEM; i++)
	{
		m_wndQuestion.InsertString(i, m_pTemplate->GetItemName(i));
	}
	m_wndQuestion.SetCurSel(m_pQuizSetting->GetQuestionIndex());

	for (i = 0; i < MAX_ITEM; i++)
	{
		m_wndAnswer.InsertString(i, m_pTemplate->GetItemName(i));
	}
	m_wndAnswer.SetCurSel(m_pQuizSetting->GetAnswerIndex());

	SendDlgItemMessage(IDC_NUM_QUIZ_SPIN,UDM_SETRANGE,0,MAKELONG(m_uiMaxCards, 1));
	SendDlgItemMessage(IDC_QUIZ_FONT_SPIN,UDM_SETRANGE,0,MAKELONG(50, 7));

	m_wndNumExample.SetCurSel(m_pQuizSetting->GetNumExample() - NUM_MIN_EXAMPLE);

	CButton* pButton;
	if (m_pQuizSetting->IsMemorizedCardOnly() == TRUE)
	{
		pButton = (CButton*)GetDlgItem(IDC_FROM_MEMORIZED_CARDS);
		pButton->SetCheck(BST_CHECKED);
	}
	else if (m_pQuizSetting->IsNotMemorizedCardOnly() == TRUE)
	{
		pButton = (CButton*)GetDlgItem(IDC_FROM_NOTMEMORIZED_CARDS);
		pButton->SetCheck(BST_CHECKED);
	}
	else if (m_pQuizSetting->IsSelectedCardOnly() == TRUE)
	{
		pButton = (CButton*)GetDlgItem(IDC_FROM_SELECTED_CARDS);
		pButton->SetCheck(BST_CHECKED);
	}
	else
	{
		pButton = (CButton*)GetDlgItem(IDC_FROM_ALL_CARDS);
		pButton->SetCheck(BST_CHECKED);
	}
	EableQuizRangeControls(m_pQuizSetting->IsSelectedCardOnly());

	UpdateData(FALSE);
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
